## zimpl 3.3.6

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.0)

project(ZIMPL
    VERSION 3.3.6
    LANGUAGES C)

# use C99 standard
set(CMAKE_C_STANDARD 99)

option(ZLIB "use ZLIB" ON)

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)

add_definitions(-DVERSION=\"${ZIMPL_VERSION_MAJOR}.${ZIMPL_VERSION_MINOR}.${ZIMPL_VERSION_PATCH}\")

# path to e.g. findGMP module
set(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake/Modules)

find_package(BISON REQUIRED)
find_package(FLEX REQUIRED)
find_package(GMP REQUIRED)

# make 'Release' the default build type
if(CMAKE_BUILD_TYPE STREQUAL "")
    set(CMAKE_BUILD_TYPE Release)
endif()
message(STATUS "Build type: ${CMAKE_BUILD_TYPE}")

# filter /MD and /MDd from C and CXX flags
if(MSVC)
    set(variables
      CMAKE_C_FLAGS_DEBUG
      CMAKE_C_FLAGS_MINSIZEREL
      CMAKE_C_FLAGS_RELEASE
      CMAKE_C_FLAGS_RELWITHDEBINFO
      CMAKE_CXX_FLAGS_DEBUG
      CMAKE_CXX_FLAGS_MINSIZEREL
      CMAKE_CXX_FLAGS_RELEASE
      CMAKE_CXX_FLAGS_RELWITHDEBINFO
    )

    foreach(variable ${variables})
       string(REGEX REPLACE "/M[T,D][ d]" "" ${variable} "${${variable}}")
       # message("${variable} = ${${variable}}")
    endforeach()
endif()

include_directories(${GMP_INCLUDE_DIRS})
set(libs ${libs} ${GMP_LIBRARIES})

if(ZLIB)
    find_package(ZLIB)
endif()
if(ZLIB_FOUND)
    set(libs ${libs} ${ZLIB_LIBRARIES})
    include_directories(${ZLIB_INCLUDE_DIRS})
else()
    add_definitions(-DWITHOUT_ZLIB)

    # look for pcre if ZLIB could not be found
    find_package(PCRE)
    if(PCRE_FOUND)
        add_definitions(-DWITH_PCRE=1)
        set(libs ${libs} ${PCRE_LIBRARIES})
        include_directories(${PCRE_INCLUDE_DIRS})
    endif()
endif()

if(MSVC)
   add_definitions(-Dpopen=_popen)
   add_definitions(-Dpclose=_pclose)
   add_definitions(-Dinline=_inline)
endif()

include(CheckSymbolExists)

# link to math library if it is available
find_library(libm m)
if(NOT libm)
  set(libm "")
endif()

set(libs ${libs} ${libm})

add_subdirectory(src)

=== Makefile ===
#* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
#*                                                                           *
#*   File....: Makefile                                                      *
#*   Name....: Zimpl Makefile                                                *
#*   Author..: Thorsten Koch                                                 *
#*   Copyright by Author, All rights reserved                                *
#*                                                                           *
#* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
#*
#* Copyright (C) 2005-2018 by Thorsten Koch <koch@zib.de>
#* 
#* This program is free software; you can redistribute it and/or
#* modify it under the terms of the GNU General Public License
#* as published by the Free Software Foundation; either version 2
#* of the License, or (at your option) any later version.
#* 
#* This program is distributed in the hope that it will be useful,
#* but WITHOUT ANY WARRANTY; without even the implied warranty of
#* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#* GNU General Public License for more details.
#* 
#* You should have received a copy of the GNU General Public License
#* along with this program; if not, write to the Free Software
#* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#*
#
.PHONY:		all depend clean lint doc doxygen check valgrind libdbl coverage

ARCH            :=      $(shell uname -m | \
                        sed \
			-e s/sun../sparc/ \
			-e s/i.86/x86/ \
			-e s/i86pc/x86/ \
			-e s/amd64/x86_64/ \
			-e s/IP../mips/ \
			-e s/9000..../hppa/ \
			-e s/Power\ Macintosh/ppc/ \
			-e s/00........../pwr4/)
OSTYPE          :=      $(shell uname -s | \
                        tr '[:upper:]' '[:lower:]' | \
			tr '/' '_' | \
                        sed \
			-e s/cygwin.*/cygwin/ \
                        -e s/irix../irix/ \
                        -e s/windows.*/windows/ \
                        -e s/mingw.*/mingw/)

HOSTNAME	:=      $(shell uname -n | tr '[:upper:]' '[:lower:]')

VERSION		=	3.3.6
VERBOSE		=	false
SHARED		=	false
STATIC		=	false
ZLIB		=	true
LINK		=	static
OPT		=	opt
COMP		=	gnu
CC		=	gcc
CC_o		= 	-o #
LINKCC   	=	gcc
LINKCC_o 	=	-o #the white space is important
LIBEXT		= 	.a
YACC		=	bison
LEX		=	flex
DCC		=	gcc
LINT		=	pclp64_linux # _debug
CPPCHECK	=	cppcheck
AR		=	ar cr
AR_o	   	=
RANLIB		=	ranlib
DOXY		=	doxygen
VALGRIND	=	valgrind --tool=memcheck --leak-check=full \
			--leak-resolution=high --show-reachable=yes 

SRCDIR		=	src/zimpl
BINDIR		=	bin
LIBDIR		=	lib
LINTCONF	=	/opt/pclint/config

CPPFLAGS	=	-I$(SRCDIR)/.. -DVERSION='"$(VERSION)"'
CFLAGS		=	-O
LDFLAGS		=	-lgmp -lm
YFLAGS		=	-d -t -v  
LFLAGS		=	-d
ARFLAGS		=	
DFLAGS		=	-MM

GCCWARN		=	-Wall -W -Wpointer-arith -Wcast-align -Wwrite-strings \
			-Wstrict-prototypes -Wmissing-prototypes -Winline \
			-Wmissing-declarations -Wshadow -Waggregate-return \
			-Wno-unused -Wno-unknown-pragmas 

ifeq ($(ZLIB),true)
LDFLAGS		+=	-lz
else
CPPFLAGS	+=	-DWITHOUT_ZLIB
endif

ifeq ($(SHARED),true)
LINK		=	shared
endif
ifeq ($(STATIC),true)
LINK		=	static
endif

BASE		=	$(OSTYPE).$(ARCH).$(COMP).$(OPT)
OBJDIR		=	obj/O.$(OSTYPE).$(ARCH).$(COMP).$(LINK).$(OPT)
NAME		=	zimpl
BINNAME		=	$(NAME)-$(VERSION).$(OSTYPE).$(ARCH).$(COMP).$(LINK).$(OPT)
LIBNAME		=	$(NAME)-$(VERSION).$(BASE)

LIBRARY		=	$(LIBDIR)/lib$(LIBNAME)$(LIBEXT)
LIBRARYDBL	=	$(LIBDIR)/lib$(LIBNAME).dbl$(LIBEXT)
LIBLINK		=	$(LIBDIR)/lib$(NAME).$(BASE)$(LIBEXT)
LIBDBLLINK	=	$(LIBDIR)/lib$(NAME).$(BASE).dbl$(LIBEXT)

BINARY		=	$(BINDIR)/$(BINNAME)
BINARYDBL	=	$(BINDIR)/$(BINNAME).dbl
BINLINK		=	$(BINDIR)/$(NAME).$(BASE)
BINSHORTLINK	=	$(BINDIR)/$(NAME)
DEPEND		=	$(SRCDIR)/depend

#-----------------------------------------------------------------------------

OBJECT  	=       zimpl.o xlpglue.o zlpglue.o \
			ratlpstore.o ratlpfwrite.o ratmpswrite.o ratmstwrite.o \
			ratordwrite.o ratpresolve.o  
LIBBASE		=	blkmem.o bound.o code.o conname.o define.o elem.o entry.o \
			hash.o heap.o idxset.o inst.o iread.o list.o \
			load.o local.o metaio.o mmlparse2.o mmlscan.o mono.o \
			mshell.o prog.o random.o rdefpar.o source.o \
			setempty.o setpseudo.o setlist.o setrange.o setprod.o \
			setmulti.o set4.o stmt.o stkchk.o strstore2.o symbol.o \
			term2.o tuple.o vinst.o zimpllib.o
LIBOBJ		=	$(LIBBASE) gmpmisc.o numbgmp.o
LIBDBLOBJ	=	$(LIBBASE) numbdbl.o
OBJXXX		=	$(addprefix $(OBJDIR)/,$(OBJECT))
LIBXXX		=	$(addprefix $(OBJDIR)/,$(LIBOBJ))
LIBDBLXXX	=	$(addprefix $(OBJDIR)/,$(LIBDBLOBJ))
OBJSRC		=	$(addprefix $(SRCDIR)/,$(OBJECT:.o=.c))
LIBSRC		=	$(addprefix $(SRCDIR)/,$(LIBOBJ:.o=.c)) #(SRCDIR)/numbdbl.c

#-----------------------------------------------------------------------------
include make/make.$(OSTYPE).$(ARCH).$(COMP).$(OPT)
-include make/local/make.$(HOSTNAME)
-include make/local/make.$(HOSTNAME).$(COMP)
-include make/local/make.$(HOSTNAME).$(COMP).$(OPT)
#-----------------------------------------------------------------------------

FLAGS           +=      $(USRFLAGS)
OFLAGS          +=      $(USROFLAGS)
CFLAGS          +=      $(USRCFLAGS) $(USROFLAGS)
LDFLAGS         +=      $(USRLDFLAGS)
ARFLAGS         +=      $(USRARFLAGS)
DFLAGS          +=      $(USRDFLAGS)


ifeq ($(VERBOSE),false)
.SILENT:	$(LIBRARY) $(LIBLINK) $(BINARY) $(BINLINK) $(BINSHORTLINK) \
		$(SRCDIR)/mmlparse2.c $(SRCDIR)/mmlscan.c $(OBJXXX) $(LIBXXX) $(LIBDBLXXX)
endif

all:		$(LIBRARY) $(LIBLINK) $(BINARY) $(BINLINK) $(BINSHORTLINK)

double:		$(LIBRARYDBL) $(LIBDBLLINK) $(BINARYDBL) # $(BINLINK) $(BINSHORTLINK)

$(LIBLINK):	$(LIBRARY)
		@rm -f $@
		cd $(dir $@) && ln -s $(notdir $(LIBRARY)) $(notdir $@)

$(LIBDBLLINK):	$(LIBRARYDBL)
		@rm -f $@
		cd $(dir $@) && ln -s $(notdir $(LIBRARYDBL)) $(notdir $@)

$(BINLINK) $(BINSHORTLINK):	$(BINARY)
		@rm -f $@
		cd $(dir $@) && ln -s $(notdir $(BINARY)) $(notdir $@)

$(BINARY):	$(OBJDIR) $(BINDIR) $(OBJXXX) $(LIBRARY) 
		@echo "-> linking $@"
ifeq ($(COMP), msvc)
		$(LINKCC) $(CFLAGS) $(OBJXXX) $(LIBRARY) $(LDFLAGS) $(LINKCC_o)$@
else
		$(LINKCC) $(CFLAGS) $(OBJXXX) -L$(LIBDIR) -l$(LIBNAME) $(LDFLAGS) $(LINKCC_o)$@
endif

$(BINARYDBL):	$(OBJDIR) $(BINDIR) $(OBJXXX) $(LIBRARYDBL) 
		@echo "-> linking $@"
		$(LINKCC) $(CFLAGS) $(OBJXXX) -L$(LIBDIR) -l$(LIBNAME).dbl $(LDFLAGS) $(CC_o)$@

$(LIBRARY):	$(OBJDIR) $(LIBDIR) $(LIBXXX) 
		@echo "-> generating library $@"
		-rm -f $(LIBRARY)
		$(AR) $(AR_o)$@ $(LIBXXX) $(ARFLAGS)
ifneq ($(RANLIB),)
		$(RANLIB) $@
endif

libdbl:		$(LIBRARYDBL) $(LIBDBLLINK)

$(LIBRARYDBL):	$(OBJDIR) $(LIBDIR) $(LIBDBLXXX) 
		@echo "-> generating library $@"
		-rm -f $(LIBRARYDBL)
		$(AR) $@ $(LIBDBLXXX) $(ARFLAGS) 
		$(RANLIB) $@

$(SRCDIR)/mmlparse2.c:	$(SRCDIR)/mmlparse2.y $(SRCDIR)/mme.h
		@echo "-> generating yacc parser $@"
		$(YACC) $(YFLAGS) -o $@ $<

$(SRCDIR)/mmlscan.c:	$(SRCDIR)/mmlscan.l $(SRCDIR)/mme.h
		@echo "-> generating lex scanner $@"
		$(LEX) $(LFLAGS) -o$@ $< 

lint:		$(OBJSRC) $(LIBSRC)
		$(LINT) $(LINTCONF)/co-gcc.lnt $(SRCDIR)/project2.lnt \
		-I$(LINTCONF) -I$(SRCDIR) -dNO_MSHELL -dVERSION='"$(VERSION)"' $^

cppcheck:	$(OBJSRC) $(LIBSRC)
		$(CPPCHECK) $(CPPFLAGS) -I/usr/include -I/usr/include/x86_64-linux-gnu -I/usr/include/x86_64-linux-gnu/bits -I/usr/include/x86_64-linux-gnu/sys -I/usr/include/linux -I/usr/lib/gcc/x86_64-linux-gnu/5/include --inline-suppr --suppressions-list=src/cppcheck.txt --enable=warning,style,performance,portability,information $^

doc:
		cd doc; make -f Makefile

doxygen:
		cd doc; $(DOXY) $(NAME).dxy

check:
		cd check; \
		/bin/sh ./check.sh ../$(BINARY) 

valgrind:
		cd check; \
		/bin/sh ./check.sh "$(VALGRIND) ../$(BINARY)" 

coverage:
		-ln -s ../../src $(OBJDIR)
		-mkdir -p gcov
		lcov -d $(OBJDIR) -z
		make OPT=gcov check
		lcov -d $(OBJDIR) -c >gcov/z.capture
		lcov -d $(OBJDIR) -r gcov/z.capture "*mmlscan.c" "*mmlparse2.c" >gcov/zimpl.capture
		genhtml -o gcov gcov/zimpl.capture
		-rm gcov/z.capture

$(OBJDIR):	
		@echo "** creating directory \"$@\""
		@-mkdir -p $(OBJDIR)

$(LIBDIR):
		@echo "** creating directory \"$@\""
		@-mkdir -p $(LIBDIR)

$(BINDIR):
		@echo "** creating directory \"$@\""
		@-mkdir -p $(BINDIR)

clean:
		-rm -rf $(OBJDIR)/* $(BINARY) $(LIBRARY) $(LIBRARYDBL) $(LIBLINK) $(BINLINK) $(BINSHORTLINK)

depend:
		$(SHELL) -ec '$(DCC) $(DFLAGS) $(CPPFLAGS) $(OBJSRC) $(LIBSRC) \
		| sed '\''s|^\([0-9A-Za-z\_]\{1,\}\)\.o|$$\(OBJDIR\)/\1.o|g'\'' \
		>$(DEPEND)'

-include	$(DEPEND)

$(OBJDIR)/%.o:	$(SRCDIR)/%.c
		@echo "-> compiling $@"
		$(CC) $(CPPFLAGS) $(CFLAGS) -c $< $(CC_o)$@

# --- EOF ---------------------------------------------------------------------

=== src/CMakeLists.txt ===
bison_target(MMLPARSE2 zimpl/mmlparse2.y ${CMAKE_CURRENT_BINARY_DIR}/zimpl/mmlparse2.c COMPILE_FLAGS -t)
flex_target(MMLSCAN zimpl/mmlscan.l ${CMAKE_CURRENT_BINARY_DIR}/zimpl/mmlscan.c)

file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/zimpl)

# add include directory for bison header
include_directories(${CMAKE_CURRENT_BINARY_DIR})

# for zimpl headers
include_directories(zimpl)

set(libsources
    zimpl/blkmem.c
    zimpl/bound.c
    zimpl/code.c
    zimpl/conname.c
    zimpl/define.c
    zimpl/elem.c
    zimpl/entry.c
    zimpl/hash.c
    zimpl/heap.c
    zimpl/idxset.c
    zimpl/inst.c
    zimpl/iread.c
    zimpl/list.c
    zimpl/load.c
    zimpl/local.c
    zimpl/metaio.c
    ${BISON_MMLPARSE2_OUTPUTS}
    ${FLEX_MMLSCAN_OUTPUTS}
    zimpl/mono.c
    zimpl/mshell.c
    zimpl/prog.c
    zimpl/random.c
    zimpl/rdefpar.c
    zimpl/source.c
    zimpl/setempty.c
    zimpl/setpseudo.c
    zimpl/setlist.c
    zimpl/setrange.c
    zimpl/setprod.c
    zimpl/setmulti.c
    zimpl/set4.c
    zimpl/stmt.c
    zimpl/stkchk.c
    zimpl/strstore2.c
    zimpl/symbol.c
    zimpl/term2.c
    zimpl/tuple.c
    zimpl/vinst.c
    zimpl/zimpllib.c)

if(GMP_FOUND)
    set(libsources ${libsources} zimpl/gmpmisc.c zimpl/numbgmp.c)
else()
    set(libsources ${libsources} zimpl/numbdbl.c)
endif()

set(binsources
    zimpl/zimpl.c
    zimpl/xlpglue.c
    zimpl/zlpglue.c
    zimpl/ratlpstore.c
    zimpl/ratlpfwrite.c
    zimpl/ratmpswrite.c
    zimpl/ratmstwrite.c
    zimpl/ratordwrite.c
    zimpl/ratpresolve.c)

set(headers
    zimpl/blkmem.h
    zimpl/bound.h
    zimpl/code.h
    zimpl/conname.h
    zimpl/define.h
    zimpl/elem.h
    zimpl/entry.h
    zimpl/gmpmisc.h
    zimpl/hash.h
    zimpl/heap.h
    zimpl/idxset.h
    zimpl/inst.h
    zimpl/lint.h
    zimpl/list.h
    zimpl/local.h
    zimpl/metaio.h
    zimpl/mme.h
    ${BISON_MMLPARSE2_OUTPUT_HEADER}
    zimpl/mono.h
    zimpl/mshell.h
    zimpl/numb.h
    zimpl/prog.h
    zimpl/random.h
    zimpl/ratlp.h
    zimpl/ratlpstore.h
    zimpl/ratlptypes.h
    zimpl/rdefpar.h
    zimpl/set4.h
    zimpl/set.h
    zimpl/stkchk.h
    zimpl/stmt.h
    zimpl/strstore.h
    zimpl/symbol.h
    zimpl/term.h
    zimpl/tuple.h
    zimpl/xlpglue.h
    zimpl/zimpllib.h
    zimpl/zlpglue.h)

include_directories(${PROJECT_SOURCE_DIR}/src)

if(MSVC)
   set(headers ${headers} WIN/unistd.h)
   set(libsources ${libsources} WIN/getopt.c)
   include_directories(${PROJECT_SOURCE_DIR}/src/WIN)
endif()

#create zimpl with pic
add_library(libzimpl-pic STATIC ${libsources})
set_target_properties(libzimpl-pic PROPERTIES POSITION_INDEPENDENT_CODE on)
target_link_libraries(libzimpl-pic ${libs})

#create zimpl without pic
add_library(libzimpl STATIC ${libsources})
target_link_libraries(libzimpl ${libs})

#create zimpl binary
add_executable(zimpl ${binsources})
target_link_libraries(zimpl libzimpl ${libs})

set_target_properties(libzimpl PROPERTIES
    OUTPUT_NAME "zimpl")

set_target_properties(libzimpl-pic PROPERTIES
    OUTPUT_NAME "zimpl-pic")

# install the header files of zimpl
install(FILES ${headers} DESTINATION include/zimpl)

# install the binary and the library to appropriate locations and add them to an export group
install(TARGETS libzimpl zimpl libzimpl-pic EXPORT zimpl-targets
        LIBRARY DESTINATION lib
        ARCHIVE DESTINATION lib
        RUNTIME DESTINATION bin
        INCLUDES DESTINATION include)

# Add library targets to the build-tree export set
export(TARGETS libzimpl libzimpl-pic
  FILE "${CMAKE_BINARY_DIR}/zimpl-targets.cmake")

#configure the config file for the build tree
set(CONF_INCLUDE_DIRS ${PROJECT_SOURCE_DIR}/src)
if(MSVC)
   set(CONF_INCLUDE_DIRS ${CONF_INCLUDE_DIRS} ${PROJECT_SOURCE_DIR}/src/WIN)
endif()

configure_file(${PROJECT_SOURCE_DIR}/zimpl-config.cmake.in
  "${CMAKE_BINARY_DIR}/zimpl-config.cmake" @ONLY)

#configure the config file for the install
set(CONF_INCLUDE_DIRS \${CMAKE_CURRENT_LIST_DIR}/../../../include)
if(MSVC)
   set(CONF_INCLUDE_DIRS ${CONF_INCLUDE_DIRS} \${CMAKE_CURRENT_LIST_DIR}/../../../include/WIN)
endif()

configure_file(${PROJECT_SOURCE_DIR}/zimpl-config.cmake.in
  "${PROJECT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/zimpl-config.cmake" @ONLY)

# install the targets of the zimpl export group and the config file so that oter projects
# can link easily against zimpl
install(EXPORT zimpl-targets FILE zimpl-targets.cmake DESTINATION lib/cmake/zimpl)
install(FILES "${PROJECT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/zimpl-config.cmake" DESTINATION lib/cmake/zimpl)

=== debian/changelog ===
zimpl (3.3.6-4) unstable; urgency=medium


  * Change Build-Depends: debhelper (>= 11) to debhelper-compat (= 13).
  * Add Vcs-* fields to debian/control.
  * Add patch use-utf8-in-examples.
  * Update patch fix-warnings to fix a new bison warning.

 -- Joachim Reichel <reichel@debian.org>  Sat, 14 Nov 2020 10:38:08 +0100

zimpl (3.3.6-3) unstable; urgency=medium

  * Add autopkgtest support.
  * Update Standards-Version to 4.5.0 (no changes needed)
  * Remove extra code in override_dh_auto_clean target for test w215
    (integrated upstream).

 -- Joachim Reichel <reichel@debian.org>  Tue, 17 Mar 2020 19:07:09 +0100

zimpl (3.3.6-2) unstable; urgency=medium

  * Attempt to fix FTBFS in parallel builds by adding order dependency for
    src/zimpl/mmlparse2.h.
  * Fix sprintf() warnings (no real issue if assertions hold).
  * Update Standards-Version to 4.4.0 (no changes needed).
  * Add Rules-Requires-Root: no to debian/control.

 -- Joachim Reichel <reichel@debian.org>  Tue, 20 Aug 2019 19:39:36 +0200

zimpl (3.3.6-1) unstable; urgency=medium

  * New upstream release.
  * Update Standards-Version to 4.2.1 (no changes needed).
  * Uses Files-Excluded: in debian/copyright, remove get-orig-source
    target in debian/rules.
  * Update content of debian/copyright.

 -- Joachim Reichel <reichel@debian.org>  Sat, 24 Nov 2018 13:16:45 +0100

=== debian/control ===
Source: zimpl
Section: science
Priority: optional
Maintainer: Joachim Reichel <reichel@debian.org>
Build-Depends: bison,
  debhelper-compat (= 13),
  flex,
  libgmp-dev,
  zlib1g-dev
Standards-Version: 4.5.0
Rules-Requires-Root: no
Homepage: http://zimpl.zib.de/
Vcs-Git: https://salsa.debian.org/reichel/zimpl.git
Vcs-Browser: https://salsa.debian.org/reichel/zimpl

Package: zimpl
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: glpk-utils
Description: mathematical modeling language for optimization problems
 Zimpl allows the specification of certain optimization problems - linear
 programs (LPs) and mixed integer programs (MIPs) - in a high-level
 description language. These descriptions can be converted into the
 LP or MPS file formats which are understood by LP and MIP solvers.

=== debian/rules ===
#!/usr/bin/make -f

# export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_build:
	CFLAGS="$(CFLAGS)" CPPFLAGS="$(CPPFLAGS)" dh_auto_build -- VERBOSE=true

override_dh_auto_test:
	CFLAGS="$(CFLAGS)" CPPFLAGS="$(CPPFLAGS)" dh_auto_test -- VERBOSE=true

override_dh_install:
	# replace symbolic link bin/zimpl by the link target
	cp -L bin/zimpl bin/zimpl.real
	rm bin/zimpl
	mv bin/zimpl.real bin/zimpl
	dh_install bin/zimpl usr/bin

override_dh_installexamples:
	dh_installexamples example/*

override_dh_installman:
	dh_installman doc/zimpl.man

override_dh_auto_clean:
	dh_auto_clean
	cd src/zimpl && rm -f mmlparse2.c mmlparse2.h mmlparse2.output mmlscan.c

## zimpl 3.7.0%2Bds

=== debian/control ===
Source: zimpl
Section: science
Maintainer: Debian Math Team <team+math@tracker.debian.org>
Uploaders: Doug Torrance <dtorrance@debian.org>
Build-Depends: bison,
               cmake,
               debhelper-compat (= 13),
               flex,
               ghostscript,
               libgmp-dev,
               texlive-fonts-extra,
               texlive-latex-base,
               texlive-latex-recommended,
               zlib1g-dev
Standards-Version: 4.7.3
Homepage: http://zimpl.zib.de/
Vcs-Git: https://salsa.debian.org/math-team/zimpl.git
Vcs-Browser: https://salsa.debian.org/math-team/zimpl

Package: zimpl
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: glpk-utils
Description: mathematical modeling language for optimization problems (binary)
 Zimpl allows the specification of certain optimization problems - linear
 programs (LPs) and mixed integer programs (MIPs) - in a high-level
 description language. These descriptions can be converted into the
 LP or MPS file formats which are understood by LP and MIP solvers.
 .
 This package contains the zimpl binary.

Package: libzimpl0
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: mathematical modeling language for optimization problems (library)
 Zimpl allows the specification of certain optimization problems - linear
 programs (LPs) and mixed integer programs (MIPs) - in a high-level
 description language. These descriptions can be converted into the
 LP or MPS file formats which are understood by LP and MIP solvers.
 .
 This package contains the zimpl shared library.

Package: libzimpl-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends}, libzimpl0 (= ${binary:Version})
Description: mathematical modeling language for optimization problems (development)
 Zimpl allows the specification of certain optimization problems - linear
 programs (LPs) and mixed integer programs (MIPs) - in a high-level
 description language. These descriptions can be converted into the
 LP or MPS file formats which are understood by LP and MIP solvers.
 .
 This package contains the zimpl development tools.

## zimpl 3.7.0+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,13 +1,62 @@
-cmake_minimum_required(VERSION 3.0.0)
+cmake_minimum_required(VERSION 3.11)
 
 project(ZIMPL
-    VERSION 3.3.6
+    VERSION 3.7.0
     LANGUAGES C)
+
+if(CMAKE_BUILD_TYPE STREQUAL "Debug")
+    # if changing these flags, also update GCCWARN/GXXWARN in make/make.project
+    if((CMAKE_C_COMPILER_ID MATCHES "GNU") OR (CMAKE_C_COMPILER_ID MATCHES "Clang"))
+        set(ADD_C_FLAGS -Wall -Wextra -Wno-unknown-pragmas -Wpointer-arith -Wcast-align -Wwrite-strings -Winline -Wshadow -Wstrict-prototypes -Wmissing-prototypes -Wmissing-noreturn -Wmissing-declarations -fno-omit-frame-pointer)
+    endif()
+
+    add_compile_options(${ADD_C_FLAGS})
+    if(CMAKE_C_COMPILER_ID MATCHES "GNU")
+        set(ADD_GNU_FLAGS -Wsuggest-attribute=format -Wno-suggest-attribute=noreturn )
+        add_compile_options(${ADD_GNU_FLAGS})
+        if (CMAKE_C_COMPILER_VERSION VERSION_LESS 5)
+            message(WARNING "GCC version smaller than 5, it is recommended to use version 10 or higher.")
+            add_compile_options(-Wno-nonnull-compare -Wno-unused-parameter -Wno-unused-function -Wno-pragmas -Wno-clobbered -Wno-attributes)
+        elseif (CMAKE_C_COMPILER_VERSION VERSION_LESS 8)
+            message(WARNING "GCC version smaller than 8, it is recommended to use version 10 or higher.")
+            add_compile_options(-Wno-nonnull-compare -Wno-unused-parameter -Wno-unused-function -fstack-protector-strong -Wduplicated-branches)
+        elseif (CMAKE_C_COMPILER_VERSION VERSION_LESS 9)
+            message(WARNING "GCC version smaller than 9, it is recommended to use version 10 or higher.")
+            add_compile_options(-Wno-strict-overflow -Wno-nonnull-compare -Wno-unused-parameter -Wno-unused-function -fstack-protector-strong -Wduplicated-branches)
+        else() # gcc 10 or later
+            add_compile_options(-Wno-strict-overflow -Wno-unused-parameter -Wno-unused-function -Wsuggest-attribute=const -Wsuggest-attribute=pure -Wsuggest-attribute=malloc -Wsuggest-attribute=cold -Wstrict-overflow=4 -fstack-protector-strong -Wduplicated-branches -Wno-nonnull-compare)
+        endif()
+    elseif(CMAKE_C_COMPILER_ID MATCHES "Clang")
+        set(ADD_CLANG_FLAGS -Wno-unused-parameter -Wno-unused-function -Wno-cast-align -Wno-strict-prototypes -Wno-pragmas -Wno-attributes -Wstrict-overflow=4 -fstack-protector-strong -Wno-invalid-command-line-argument)
+        set(EXTRA_CLANG_FLAGS -Weverything -Wno-reserved-id-macro -Wno-cast-qual -Wno-bad-function-cast -Wno-float-equal -Wno-unused-macros -Wno-implicit-fallthrough -Wno-switch-enum -Wno-padded -Wno-covered-switch-default -Wno-shorten-64-to-32 -Wno-pedantic -Wno-format-nonliteral -Wno-disabled-macro-expansion -Wno-static-in-inline)
+        add_compile_options(${ADD_CLANG_FLAGS} ${EXTRA_CLANG_FLAGS})
+        if (CMAKE_C_COMPILER_VERSION VERSION_LESS 7)
+            message(WARNING "Clang version smaller than 7, it is recommended to use version 10 or higher.")
+        else()
+            add_compile_options(-Wno-extra-semi-stmt)
+        endif()
+    endif()
+endif()
+
+# disable fused floating point contraction to enhance reproducibility across compilers and architectures
+if(CMAKE_C_COMPILER_ID MATCHES "MSVC")
+    add_compile_options(/fp:precise)
+elseif(CMAKE_C_COMPILER_ID MATCHES "Intel")
+    add_compile_options(-fp-model=precise -wd111,151,171,279,981,1173,1419,1684,2259)
+elseif((CMAKE_C_COMPILER_ID MATCHES "GNU") OR (CMAKE_C_COMPILER_ID MATCHES "Clang"))
+    add_compile_options(-ffp-contract=off)
+endif()
 
 # use C99 standard
 set(CMAKE_C_STANDARD 99)
+set(CMAKE_C_VISIBILITY_PRESET hidden)
+set(CMAKE_VISIBILITY_INLINES_HIDDEN 1)
 
 option(ZLIB "use ZLIB" ON)
+option(SANITIZE_ADDRESS "should the address sanitizer be enabled in debug mode if available" OFF)
+option(SANITIZE_MEMORY "should the memory sanitizer be enabled in debug mode if available" OFF)
+option(SANITIZE_UNDEFINED "should the undefined behavior sanitizer be enabled in debug mode if available" OFF)
+option(SANITIZE_THREAD "should the thread sanitizer be enabled in debug mode if available" OFF)
 
 set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
 set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
@@ -16,9 +65,38 @@
 add_definitions(-DVERSION=\"${ZIMPL_VERSION_MAJOR}.${ZIMPL_VERSION_MINOR}.${ZIMPL_VERSION_PATCH}\")
 
 # path to e.g. findGMP module
-set(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake/Modules)
+list(APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake/Modules)
 
-find_package(BISON REQUIRED)
+# On macOS, search Homebrew for keg-only versions of Bison and Flex. Xcode does
+# not provide new enough versions for us to use.
+if (CMAKE_HOST_SYSTEM_NAME MATCHES "Darwin")
+    find_program(BREW brew)
+    if(DEFINED BREW)
+        execute_process(
+            COMMAND ${BREW} --prefix bison
+            RESULT_VARIABLE BREW_BISON
+            OUTPUT_VARIABLE BREW_BISON_PREFIX
+            OUTPUT_STRIP_TRAILING_WHITESPACE
+        )
+        if (BREW_BISON EQUAL 0 AND EXISTS "${BREW_BISON_PREFIX}")
+            message(STATUS "Found Bison keg installed by Homebrew at ${BREW_BISON_PREFIX}")
+            set(BISON_EXECUTABLE "${BREW_BISON_PREFIX}/bin/bison")
+        endif()
+
+        execute_process(
+            COMMAND ${BREW} --prefix flex
+            RESULT_VARIABLE BREW_FLEX
+            OUTPUT_VARIABLE BREW_FLEX_PREFIX
+            OUTPUT_STRIP_TRAILING_WHITESPACE
+        )
+        if (BREW_FLEX EQUAL 0 AND EXISTS "${BREW_FLEX_PREFIX}")
+            message(STATUS "Found Flex keg installed by Homebrew at ${BREW_FLEX_PREFIX}")
+            set(FLEX_EXECUTABLE "${BREW_FLEX_PREFIX}/bin/flex")
+        endif()
+    endif()
+endif()
+
+find_package(BISON 2.4.0 REQUIRED)
 find_package(FLEX REQUIRED)
 find_package(GMP REQUIRED)
 
@@ -58,11 +136,14 @@
     include_directories(${ZLIB_INCLUDE_DIRS})
 else()
     add_definitions(-DWITHOUT_ZLIB)
+endif()
 
-    # look for pcre if ZLIB could not be found
+if(MSVC)
+    # look for pcre if Windows
     find_package(PCRE)
     if(PCRE_FOUND)
-        add_definitions(-DWITH_PCRE=1)
+        add_definitions(-DWITH_PCRE)
+        add_definitions(-DPCRE2_STATIC)
         set(libs ${libs} ${PCRE_LIBRARIES})
         include_directories(${PCRE_INCLUDE_DIRS})
     endif()

=== Makefile ===
--- 
+++ 
@@ -7,18 +7,18 @@
 #*                                                                           *
 #* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 #*
-#* Copyright (C) 2005-2018 by Thorsten Koch <koch@zib.de>
-#* 
+#* Copyright (C) 2005-2025 by Thorsten Koch <koch@zib.de>
+#*
 #* This program is free software; you can redistribute it and/or
 #* modify it under the terms of the GNU General Public License
 #* as published by the Free Software Foundation; either version 2
 #* of the License, or (at your option) any later version.
-#* 
+#*
 #* This program is distributed in the hope that it will be useful,
 #* but WITHOUT ANY WARRANTY; without even the implied warranty of
 #* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 #* GNU General Public License for more details.
-#* 
+#*
 #* You should have received a copy of the GNU General Public License
 #* along with this program; if not, write to the Free Software
 #* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
@@ -26,16 +26,17 @@
 #
 .PHONY:		all depend clean lint doc doxygen check valgrind libdbl coverage
 
-ARCH            :=      $(shell uname -m | \
-                        sed \
-			-e s/sun../sparc/ \
-			-e s/i.86/x86/ \
-			-e s/i86pc/x86/ \
-			-e s/amd64/x86_64/ \
-			-e s/IP../mips/ \
-			-e s/9000..../hppa/ \
-			-e s/Power\ Macintosh/ppc/ \
-			-e s/00........../pwr4/)
+ARCH		:=	$(shell uname -m | \
+			sed \
+			-e 's/sun../sparc/' \
+			-e 's/i.86/x86/' \
+			-e 's/i86pc/x86/' \
+			-e 's/[0-9]86/x86/' \
+			-e 's/amd64/x86_64/' \
+			-e 's/9000..../hppa/' \
+			-e 's/00........../pwr4/' \
+			-e 's/arm.*/arm/' \
+			-e 's/aarch64/arm/')
 OSTYPE          :=      $(shell uname -s | \
                         tr '[:upper:]' '[:lower:]' | \
 			tr '/' '_' | \
@@ -47,13 +48,13 @@
 
 HOSTNAME	:=      $(shell uname -n | tr '[:upper:]' '[:lower:]')
 
-VERSION		=	3.3.6
+VERSION		=  3.7.0
 VERBOSE		=	false
 SHARED		=	false
 STATIC		=	false
 ZLIB		=	true
 LINK		=	static
-OPT		=	opt
+OPT		=	dbg
 COMP		=	gnu
 CC		=	gcc
 CC_o		= 	-o #
@@ -70,7 +71,8 @@
 RANLIB		=	ranlib
 DOXY		=	doxygen
 VALGRIND	=	valgrind --tool=memcheck --leak-check=full \
-			--leak-resolution=high --show-reachable=yes 
+			--leak-resolution=high --show-reachable=yes
+ANALYZER	=	scan-build
 
 SRCDIR		=	src/zimpl
 BINDIR		=	bin
@@ -80,15 +82,62 @@
 CPPFLAGS	=	-I$(SRCDIR)/.. -DVERSION='"$(VERSION)"'
 CFLAGS		=	-O
 LDFLAGS		=	-lgmp -lm
-YFLAGS		=	-d -t -v  
+YFLAGS		=	-d -t -v
 LFLAGS		=	-d
-ARFLAGS		=	
+ARFLAGS		=
 DFLAGS		=	-MM
-
-GCCWARN		=	-Wall -W -Wpointer-arith -Wcast-align -Wwrite-strings \
-			-Wstrict-prototypes -Wmissing-prototypes -Winline \
-			-Wmissing-declarations -Wshadow -Waggregate-return \
-			-Wno-unused -Wno-unknown-pragmas 
+# if changing these flags, also update ADD_C_FLAGS in CMakeLists.txt
+GCCWARN		=	-Wall \
+			-Wextra \
+			-Wno-unknown-pragmas \
+			-Wno-nonnull-compare \
+			-Wno-cast-qual \
+			-Wpointer-arith \
+			-Wcast-align \
+			-Wwrite-strings \
+			-Winline \
+			-Wshadow \
+			-Wstrict-prototypes \
+			-Wmissing-prototypes \
+			-Wmissing-declarations \
+			-Wmissing-noreturn \
+			-Wstrict-overflow=4 \
+			-Wduplicated-branches \
+			-Wsuggest-attribute=pure \
+			-Wsuggest-attribute=const \
+			-Wsuggest-attribute=noreturn \
+			-Wsuggest-attribute=format \
+			-Wno-attributes \
+			-Wno-unused-function \
+			-Wno-unused-parameter \
+			-Wno-nonnull-compare \
+			-Wno-strict-overflow \
+			-fno-omit-frame-pointer \
+			-fstack-protector-strong \
+			-fsanitize=address \
+			-fsanitize=undefined \
+			-fsanitize=shift \
+			-fsanitize=shift-exponent \
+			-fsanitize=shift-base \
+			-fsanitize=integer-divide-by-zero \
+			-fsanitize=unreachable \
+			-fsanitize=vla-bound \
+			-fsanitize=null \
+			-fsanitize=bounds \
+			-fsanitize=alignment \
+			-fsanitize=object-size \
+			-fsanitize=float-cast-overflow \
+			-fsanitize=nonnull-attribute \
+			-fsanitize=returns-nonnull-attribute \
+			-fsanitize=bool \
+			-fsanitize=enum \
+			-fsanitize=signed-integer-overflow \
+#			-Wsuggest-attribute=malloc \
+#			-Wsuggest-attribute=cold \
+#			-fsanitize=pointer-overflow \
+#			-fsanitize=builtin 
+#			-fsanitize=float-divide-by-zero \
+#			-fsanitize=bounds-strict \
 
 ifeq ($(ZLIB),true)
 LDFLAGS		+=	-lz
@@ -124,7 +173,7 @@
 
 OBJECT  	=       zimpl.o xlpglue.o zlpglue.o \
 			ratlpstore.o ratlpfwrite.o ratmpswrite.o ratmstwrite.o \
-			ratordwrite.o ratpresolve.o  
+			ratopbwrite.o ratordwrite.o ratpresolve.o ratqbowrite.o
 LIBBASE		=	blkmem.o bound.o code.o conname.o define.o elem.o entry.o \
 			hash.o heap.o idxset.o inst.o iread.o list.o \
 			load.o local.o metaio.o mmlparse2.o mmlscan.o mono.o \
@@ -176,7 +225,7 @@
 		@rm -f $@
 		cd $(dir $@) && ln -s $(notdir $(BINARY)) $(notdir $@)
 
-$(BINARY):	$(OBJDIR) $(BINDIR) $(OBJXXX) $(LIBRARY) 
+$(BINARY):	$(OBJDIR) $(BINDIR) $(OBJXXX) $(LIBRARY)
 		@echo "-> linking $@"
 ifeq ($(COMP), msvc)
 		$(LINKCC) $(CFLAGS) $(OBJXXX) $(LIBRARY) $(LDFLAGS) $(LINKCC_o)$@
@@ -184,11 +233,11 @@
 		$(LINKCC) $(CFLAGS) $(OBJXXX) -L$(LIBDIR) -l$(LIBNAME) $(LDFLAGS) $(LINKCC_o)$@
 endif
 
-$(BINARYDBL):	$(OBJDIR) $(BINDIR) $(OBJXXX) $(LIBRARYDBL) 
+$(BINARYDBL):	$(OBJDIR) $(BINDIR) $(OBJXXX) $(LIBRARYDBL)
 		@echo "-> linking $@"
 		$(LINKCC) $(CFLAGS) $(OBJXXX) -L$(LIBDIR) -l$(LIBNAME).dbl $(LDFLAGS) $(CC_o)$@
 
-$(LIBRARY):	$(OBJDIR) $(LIBDIR) $(LIBXXX) 
+$(LIBRARY):	$(OBJDIR) $(LIBDIR) $(LIBXXX)
 		@echo "-> generating library $@"
 		-rm -f $(LIBRARY)
 		$(AR) $(AR_o)$@ $(LIBXXX) $(ARFLAGS)
@@ -198,10 +247,10 @@
 
 libdbl:		$(LIBRARYDBL) $(LIBDBLLINK)
 
-$(LIBRARYDBL):	$(OBJDIR) $(LIBDIR) $(LIBDBLXXX) 
+$(LIBRARYDBL):	$(OBJDIR) $(LIBDIR) $(LIBDBLXXX)
 		@echo "-> generating library $@"
 		-rm -f $(LIBRARYDBL)
-		$(AR) $@ $(LIBDBLXXX) $(ARFLAGS) 
+		$(AR) $@ $(LIBDBLXXX) $(ARFLAGS)
 		$(RANLIB) $@
 
 $(SRCDIR)/mmlparse2.c:	$(SRCDIR)/mmlparse2.y $(SRCDIR)/mme.h
@@ -210,11 +259,11 @@
 
 $(SRCDIR)/mmlscan.c:	$(SRCDIR)/mmlscan.l $(SRCDIR)/mme.h
 		@echo "-> generating lex scanner $@"
-		$(LEX) $(LFLAGS) -o$@ $< 
+		$(LEX) $(LFLAGS) -o$@ $<
 
 lint:		$(OBJSRC) $(LIBSRC)
 		$(LINT) $(LINTCONF)/co-gcc.lnt $(SRCDIR)/project2.lnt \
-		-I$(LINTCONF) -I$(SRCDIR) -dNO_MSHELL -dVERSION='"$(VERSION)"' $^
+		-I$(LINTCONF) -I$(SRCDIR)/.. -dNO_MSHELL -dVERSION='"$(VERSION)"' $^
 
 cppcheck:	$(OBJSRC) $(LIBSRC)
 		$(CPPCHECK) $(CPPFLAGS) -I/usr/include -I/usr/include/x86_64-linux-gnu -I/usr/include/x86_64-linux-gnu/bits -I/usr/include/x86_64-linux-gnu/sys -I/usr/include/linux -I/usr/lib/gcc/x86_64-linux-gnu/5/include --inline-suppr --suppressions-list=src/cppcheck.txt --enable=warning,style,performance,portability,information $^
@@ -226,12 +275,17 @@
 		cd doc; $(DOXY) $(NAME).dxy
 
 check:
+		export GLIBC_TUNABLES=glibc.malloc.check=3
 		cd check; \
-		/bin/sh ./check.sh ../$(BINARY) 
+		/bin/sh ./check.sh ../$(BINARY)
 
 valgrind:
 		cd check; \
-		/bin/sh ./check.sh "$(VALGRIND) ../$(BINARY)" 
+		/bin/sh ./check.sh "$(VALGRIND) ../$(BINARY)"
+
+analyze:
+		make clean
+		$(ANALYZER) make
 
 coverage:
 		-ln -s ../../src $(OBJDIR)
@@ -243,7 +297,7 @@
 		genhtml -o gcov gcov/zimpl.capture
 		-rm gcov/z.capture
 
-$(OBJDIR):	
+$(OBJDIR):
 		@echo "** creating directory \"$@\""
 		@-mkdir -p $(OBJDIR)

=== doc/Makefile ===
#* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
#*                                                                           *
#*   File....: Makefile                                                      *
#*   Name....: ZIMPL Documentation makefile                                  *
#*   Author..: Thorsten Koch                                                 *
#*   Copyright by Author, All rights reserved                                *
#*                                                                           *
#* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
#
#    Copyright (C) 2001-2025 by Thorsten Koch <koch@zib.de>
# 
#    This program is free software; you can redistribute it and/or
#    modify it under the terms of the GNU General Public License
#    as published by the Free Software Foundation; either version 2
#    of the License, or (at your option) any later version.
# 
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
# 
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#

.PHONY:		clean spell all

all:		zimpl.pdf

#zimpl.pdf:	zimpl.tex zimplug.tex zimplerr.tex zimpl.bib ziblogo2.eps
#		pdflatex zimpl
#		bibtex zimpl
#		pdflatex zimpl
#		pdflatex zimpl

zimpl.pdf:	zimpl.ps
		ps2pdf14 zimpl.ps

zimpl.ps:	zimpl.dvi
		dvips -ta4 -O0in,-1in -o $@ zimpl.dvi

zimpl.dvi:	zimpl.tex zimplug.tex zimplerr.tex zimpl.bib ziblogo2.eps
		latex -halt-on-error zimpl
		bibtex zimpl
		latex -halt-on-error zimpl
		latex -halt-on-error zimpl

zimpl.man.ps:	zimpl.man
		groff -man -Tps zimpl.man >zimpl.man.ps

spell:
		ispell -t -S zimpl.tex zimplug.tex

clean:
		-rm -f *.aux *.log *.bbl *.blg zimpl.dvi zimpl.ps

# --- EOF ---------------------------------------------------------------------

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -4,10 +4,10 @@
 file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/zimpl)
 
 # add include directory for bison header
-include_directories(${CMAKE_CURRENT_BINARY_DIR})
+include_directories(BEFORE ${CMAKE_CURRENT_BINARY_DIR})
 
 # for zimpl headers
-include_directories(zimpl)
+include_directories(BEFORE zimpl)
 
 set(libsources
     zimpl/blkmem.c
@@ -64,10 +64,13 @@
     zimpl/ratlpfwrite.c
     zimpl/ratmpswrite.c
     zimpl/ratmstwrite.c
+    zimpl/ratopbwrite.c
     zimpl/ratordwrite.c
+    zimpl/ratqbowrite.c
     zimpl/ratpresolve.c)
 
 set(headers
+    zimpl/attribute.h
     zimpl/blkmem.h
     zimpl/bound.h
     zimpl/code.h
@@ -107,7 +110,7 @@
     zimpl/zimpllib.h
     zimpl/zlpglue.h)
 
-include_directories(${PROJECT_SOURCE_DIR}/src)
+include_directories(BEFORE ${PROJECT_SOURCE_DIR}/src)
 
 if(MSVC)
    set(headers ${headers} WIN/unistd.h)
@@ -128,21 +131,37 @@
 add_executable(zimpl ${binsources})
 target_link_libraries(zimpl libzimpl ${libs})
 
+if(CMAKE_BUILD_TYPE STREQUAL "Debug")
+    if (SANITIZE_ADDRESS OR SANITIZE_MEMORY OR SANITIZE_THREAD OR SANITIZE_UNDEFINED)
+        find_package(Sanitizers)
+        add_sanitizers(zimpl)
+    endif()
+endif()
+
 set_target_properties(libzimpl PROPERTIES
     OUTPUT_NAME "zimpl")
 
 set_target_properties(libzimpl-pic PROPERTIES
     OUTPUT_NAME "zimpl-pic")
 
+include(GNUInstallDirs)
+
 # install the header files of zimpl
-install(FILES ${headers} DESTINATION include/zimpl)
+install(FILES ${headers} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/zimpl)
 
 # install the binary and the library to appropriate locations and add them to an export group
 install(TARGETS libzimpl zimpl libzimpl-pic EXPORT zimpl-targets
-        LIBRARY DESTINATION lib
-        ARCHIVE DESTINATION lib
-        RUNTIME DESTINATION bin
-        INCLUDES DESTINATION include)
+        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
+        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
+        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
+        INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
+
+if(MSVC)
+    install(FILES $<TARGET_PDB_FILE:zimpl> DESTINATION ${CMAKE_INSTALL_BINDIR} OPTIONAL)
+endif()
+
+# install the license file of ZIMPL
+install(FILES ${PROJECT_SOURCE_DIR}/LICENSE DESTINATION ${CMAKE_INSTALL_DATADIR}/licenses/zimpl)
 
 # Add library targets to the build-tree export set
 export(TARGETS libzimpl libzimpl-pic
@@ -166,7 +185,16 @@
 configure_file(${PROJECT_SOURCE_DIR}/zimpl-config.cmake.in
   "${PROJECT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/zimpl-config.cmake" @ONLY)
 
+include(CMakePackageConfigHelpers)
+write_basic_package_version_file(
+	 ${CMAKE_BINARY_DIR}/zimpl-config-version.cmake
+	 VERSION ${ZIMPL_VERSION_MAJOR}.${ZIMPL_VERSION_MINOR}.${ZIMPL_VERSION_PATCH}
+	 COMPATIBILITY SameMajorVersion
+	 )
+
 # install the targets of the zimpl export group and the config file so that oter projects
 # can link easily against zimpl
-install(EXPORT zimpl-targets FILE zimpl-targets.cmake DESTINATION lib/cmake/zimpl)
-install(FILES "${PROJECT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/zimpl-config.cmake" DESTINATION lib/cmake/zimpl)
+install(EXPORT zimpl-targets FILE zimpl-targets.cmake DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/zimpl)
+install(FILES "${PROJECT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/zimpl-config.cmake"
+   "${CMAKE_BINARY_DIR}/zimpl-config-version.cmake"
+   DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/zimpl)

=== debian/changelog ===
zimpl (3.7.0+ds-2) unstable; urgency=medium

  * Source-only upload for transition to testing.
  * ddebian/control
    - Use https in Homepage.

 -- Doug Torrance <dtorrance@debian.org>  Wed, 25 Feb 2026 06:06:40 -0500

zimpl (3.7.0+ds-1) unstable; urgency=medium

  * Re-introduce to Debian (Closes: #1126464).
  * Split into three binary packages (zimpl, libzimpl0, and libzimpl-devel).
  * debian/control
    - Update Maintainer (now Debian Math Team) and add Uploaders field.
    - Update Vcs-* fields.
    - Drop Priority field; "optional" is now the default.
    - Drop redundant Rules-Requires-Root field.
    - Bump Standards-Version to 4.7.3.
    - Add cmake to Build-Depends
    - Add ghostscript, texlive-fonts-extra, texlive-latex-recommded, and
      texlive-latex-base to Build-Depends for building documentation.
  * debian/copyright
    - Stop excluding documentation pdf; its source is included.
    - Remove some directories that aren't included in the tarball generated
      by scripts/makedist.sh (which doesn't appear to be hosted anywhere).
      Some of the files have questionable licenses (images, etc.).
    - Remove old physical Free Software Foundation address from license texts.
    - Update upstream copyright years.
    - Add license info for some cmake files.
    - Add myself to copyright holders for debian directory.
  * debian/gbp.conf
    - New file; set pristine-tar to True and debian-branch to
      debian/latest.
  * debian/libzimpl0.symbols
    - Add symbols file.
  * debian/patches/adapt-build-system
    - Remove patch; we now use the cmake build.
  * debian/patches/check-abort.patch
    - Only check for "Aborted" in error tests. Sometimes "(core dumped)"
      doesn't appear (e.g., on Salsa CI runners).
  * debian/patches/display-test-failures
    - Remove patch to minimize diff from upstream and ease maintenance.
  * debian/patches/fix-warnings
    - Remove patch; issues fixed upstream.
  * debian/patches/shared-library.patch
    - New patch from Fedora; build a shared library.
  * debian/patches
    - Add .patch suffix to remaining patches so Emacs fires up the correct
      major mode.
  * debian/README.Debian
    - Remove file; no longer accurate as we now distribute the
      documentation.
  * debian/README.source
    - Remove file; the fact that we use quilt is clear from "3.0 (quilt)"
      in d/source/format, so no reason to document it further.
  * debian/rules
    - Switch buildsystem to cmake.
    - Drop override_dh_auto_build target; no longer necessary to manually
      set build flags.
    - Remove override_dh_install target; dh_install now does the right
      thing by default.
    - Remove DH_VERBOSE comment.
    - Remove unnecessary override_dh_auto_clean target.
    - Update override_dh_auto_test target to run check.sh script.
    - Add execute_after_dh_auto_build target for building documentation.
    - Add execute_after_dh_auto_clean target for cleaning up artifacts
      from building documentation.
  * debian/salsa-ci.yml
    - Add Salsa CI config file.
  * debian/tests/control
    - Set Depends for autopkgtest to be just zimpl.
  * debian/watch
    - Use uscan v4.
    - Update to use GitHub tags.
    - Deal with repack suffix.
  * debian/zimpl.doc-base
    - New file; register documentation with doc-base.
  * debian/zimpl.docs
    - Rename from docs.
    - Install pdf documentation.

 -- Doug Torrance <dtorrance@debian.org>  Mon, 26 Jan 2026 19:58:25 -0500

=== debian/control ===
--- 
+++ 
@@ -13,7 +13,7 @@
                texlive-latex-recommended,
                zlib1g-dev
 Standards-Version: 4.7.3
-Homepage: http://zimpl.zib.de/
+Homepage: https://zimpl.zib.de/
 Vcs-Git: https://salsa.debian.org/math-team/zimpl.git
 Vcs-Browser: https://salsa.debian.org/math-team/zimpl

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk # for DEB_HOST_GNU_TYPE

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --buildsystem=cmake

execute_after_dh_auto_build:
	$(MAKE) -C doc

LIBDIR = $(CURDIR)/obj-$(DEB_HOST_GNU_TYPE)/lib
BINDIR = ../obj-$(DEB_HOST_GNU_TYPE)/bin
override_dh_auto_test:
	cd check && LD_LIBRARY_PATH=$(LIBDIR) sh check.sh $(BINDIR)/zimpl

override_dh_installexamples:
	dh_installexamples example/*

override_dh_installman:
	dh_installman doc/zimpl.man

execute_after_dh_auto_clean:
	$(MAKE) -C doc clean

=== debian/watch ===
version=4
# we assume that 3-digit tags need dots, e.g., v362 -> 3.6.2
opts=uversionmangle=s/^([0-9])([0-9])([0-9])$/$1.$2.$3/,\
repacksuffix=+ds,dversionmangle=auto,repack \
https://github.com/scipopt/zimpl/tags .*/@ANY_VERSION@@ARCHIVE_EXT@
